SystemOrganization addCategory: #'Pier-Slideshow'!

PRWidget subclass: #PRSlideshow
	instanceVariableNames: 'slides current ajaxId'
	classVariableNames: 'NoChildrenFound'
	poolDictionaries: ''
	category: 'Pier-Slideshow'!

!PRSlideshow class methodsFor: 'initialization' stamp: 'lr 8/22/2007 11:59'!
initialize
	NoChildrenFound := PRPage named: 'unnamed'.
	NoChildrenFound
		contents: 'Please add slides to this widget.'! !

!PRSlideshow class methodsFor: 'accessing-descriptions' stamp: 'lr 8/22/2007 14:00'!
descriptionFirstLast
	^ MABooleanDescription new
		selectorAccessor: #firstLast;
		label: 'Navigation Controls';
		checkboxLabel: 'First/Last';
		default: true;
		priority: 200;
		yourself! !

!PRSlideshow class methodsFor: 'accessing-descriptions' stamp: 'lr 8/22/2007 13:26'!
descriptionPrevNext
	^ MABooleanDescription new
		selectorAccessor: #prevNext;
		checkboxLabel: 'Previous/Next';
		default: true;
		priority: 210;
		yourself! !

!PRSlideshow class methodsFor: 'accessing-descriptions' stamp: 'lr 8/22/2007 13:56'!
descriptionSlideList
	^ MABooleanDescription new
		selectorAccessor: #slideList;
		checkboxLabel: 'Slide Listing';
		default: true;
		priority: 220;
		yourself! !

!PRSlideshow class methodsFor: 'accessing-descriptions' stamp: 'lr 8/22/2007 14:37'!
descriptionSlideNumber
	^ MABooleanDescription new
		selectorAccessor: #slideNumber;
		checkboxLabel: 'Slide Number';
		default: true;
		priority: 230;
		yourself! !

!PRSlideshow class methodsFor: 'testing' stamp: 'lr 8/22/2007 11:51'!
isAbstract
	^ false! !

!PRSlideshow class methodsFor: 'accessing' stamp: 'lr 8/22/2007 11:53'!
label
	^ 'Slideshow'! !

!PRSlideshow methodsFor: 'accessing' stamp: 'kph 3/11/2009 02:59'!
current
	"Answer the current slides to display."

	^ current ifNil: [
		current := self slides isEmpty
			ifFalse: [ self slides first ]
			ifTrue: [ NoChildrenFound ] ]! !

!PRSlideshow methodsFor: 'accessing' stamp: 'lr 8/22/2007 12:04'!
current: aStructure
	current := aStructure! !

!PRSlideshow methodsFor: 'actions' stamp: 'lr 9/12/2007 18:18'!
goFirst
	"Go to the first slide."

	self current: self slides first! !

!PRSlideshow methodsFor: 'actions' stamp: 'lr 9/12/2007 18:18'!
goLast
	"Go to the last slide."

	self current: self slides last! !

!PRSlideshow methodsFor: 'actions' stamp: 'kph 3/11/2009 04:48'!
goNext
	"Go to the next slide."
self beep.
	self current: (self slides
		after: self current
		ifAbsent: [ self slides first ])! !

!PRSlideshow methodsFor: 'actions' stamp: 'lr 9/12/2007 18:18'!
goPrev
	"Go to the previous slide."

	self current: (self slides
		before: self current
		ifAbsent: [ self slides last ])! !

!PRSlideshow methodsFor: 'rendering' stamp: 'lr 8/22/2007 12:05'!
renderContentOn: html
	html div
		class: 'slideshow';
		id: (ajaxId := html nextId);
		with: [ self renderSlideshowOn: html ]! !

!PRSlideshow methodsFor: 'rendering-controls' stamp: 'lr 3/10/2009 14:13'!
renderControl: aString class: aClassString enabled: aBoolean action: aBlock on: html
	aBoolean
		ifTrue: [
			aBlock fixCallbackTemps.
			html anchor
				callback: aBlock;
				class: aClassString;
				onClick: (html updater
					id: ajaxId;
					callback: [ :r |
						aBlock value.
						self renderSlideshowOn: r ];
					return: false);
				with: aString ]
		ifFalse: [
			html span
				class: aClassString;
				with: aString ]! !

!PRSlideshow methodsFor: 'rendering-controls' stamp: 'lr 9/12/2007 18:18'!
renderControlFirstOn: html
	self
		renderControl: '|<' class: 'first'
		enabled: self current ~= self slides first
		action: [ self goFirst ] on: html! !

!PRSlideshow methodsFor: 'rendering-controls' stamp: 'lr 9/12/2007 18:18'!
renderControlLastOn: html
	self
		renderControl: '>|' class: 'last'
		enabled: self current ~= self slides last
		action: [ self goLast ] on: html! !

!PRSlideshow methodsFor: 'rendering-controls' stamp: 'lr 9/12/2007 18:18'!
renderControlNextOn: html
	self
		renderControl: '>>' class: 'next'
		enabled: self current ~= self slides last
		action: [ self goNext ] on: html! !

!PRSlideshow methodsFor: 'rendering-controls' stamp: 'lr 9/12/2007 18:18'!
renderControlPrevOn: html
	self
		renderControl: '<<' class: 'prev'
		enabled: self current ~= self slides first
		action: [ self goPrev ] on: html! !

!PRSlideshow methodsFor: 'rendering-controls' stamp: 'lr 8/22/2007 13:56'!
renderControlSlideListOn: html
	| selectId |
	html select
		class: 'navg';
		list: self slides;
		selected: self current;
		id: (selectId := html nextId);
		callback: [ :value | self current: value ];
		labels: [ :value | (self slides indexOf: value) asString , '. ' , value title ];
		onChange: (html updater
			id: ajaxId;
			triggerFormElement: selectId;
			callback: [ :r | self renderSlideshowOn: r ])! !

!PRSlideshow methodsFor: 'rendering' stamp: 'lr 9/12/2007 18:18'!
renderSlideNumberOn: html
	html span class: 'number'; with: [
		html span
			class: 'current';
			with: (self slides indexOf: self current).
		html span
			class: 'separator';
			with: '/'.
		html span
			class: 'totoal';
			with: (self slides size) ]! !

!PRSlideshow methodsFor: 'rendering' stamp: 'lr 3/10/2009 14:16'!
renderSlideOn: html
	html div class: 'slide'; with: [ 
		self context renderer 
			continue: self current 
			in: self on: html ]! !

!PRSlideshow methodsFor: 'rendering' stamp: 'lr 8/22/2007 14:36'!
renderSlideshowOn: html
	self renderSlideOn: html.
	self slides isEmpty
		ifFalse: [ self renderToolsOn: html ]! !

!PRSlideshow methodsFor: 'rendering' stamp: 'lr 8/22/2007 14:36'!
renderToolsOn: html
	html div class: 'tools'; with: [
		(self read: #descriptionFirstLast)
			ifTrue: [ self renderControlFirstOn: html ].
		(self read: #descriptionPrevNext)
			ifTrue: [ self renderControlPrevOn: html ].
		(self read: #descriptionSlideList)
			ifTrue: [ self renderControlSlideListOn: html ].
		(self read: #descriptionPrevNext)
			ifTrue: [ self renderControlNextOn: html ].
		(self read: #descriptionFirstLast)
			ifTrue: [ self renderControlLastOn: html ].
		(self read: #descriptionSlideNumber)
			ifTrue: [ self renderSlideNumberOn: html ] ]! !

!PRSlideshow methodsFor: 'accessing' stamp: 'lr 9/12/2007 18:18'!
slides
	"Answer the possible slides to display."

	^ slides ifNil: [ slides := self structure enumerator contents ]! !

!PRSlideshow methodsFor: 'accessing' stamp: 'lr 9/12/2007 18:18'!
structure
	"Answer the owning structure, the structure this component is defined at."

	^ self context componentDictionary keyAtValue: self ifAbsent: [ nil ]! !

PRSlideshow subclass: #PRSlideshowCrossFade
	instanceVariableNames: 'previous'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Slideshow'!

!PRSlideshowCrossFade commentStamp: 'kph 3/11/2009 05:06' prior: 0!
PRSlideshowCrossFade renders all the slides, with only the current (first) visible. As the user navigates a crossfading script is applied to give a smooth transition to the next slide chosen.

Settings:
The cross fade transition time - frames are 50ms, so a 2000 ms transition time is 40 frames.
The delay time - if the delay>0 the slideshow progresses to the next slide automatically. 
Looping - whether to loop the automatic presentation,
!

!PRSlideshowCrossFade class methodsFor: 'as yet unclassified' stamp: 'kph 3/11/2009 03:13'!
descriptionDelay
	^ MANumberDescription new
		selectorAccessor: #delay;
		label: 'Auto Delay(secs)';
		default: 0;
		priority: 310;
		yourself! !

!PRSlideshowCrossFade class methodsFor: 'as yet unclassified' stamp: 'kph 3/10/2009 02:58'!
descriptionLooping
	^ MABooleanDescription new
		selectorAccessor: #isLooping;
		checkboxLabel: 'Looping';
		default: true;
		priority: 300;
		yourself! !

!PRSlideshowCrossFade class methodsFor: 'as yet unclassified' stamp: 'kph 3/11/2009 02:08'!
descriptionTransitionTime
	^ MANumberDescription new
		selectorAccessor: #transitionTime;
		label: 'Transition Time(ms)';
		default: 2000;
		priority: 320;
		yourself! !

!PRSlideshowCrossFade methodsFor: 'as yet unclassified' stamp: 'kph 3/11/2009 04:53'!
applyCrossFadeTo: script

	| indexA indexB |

	current = previous ifTrue: [ ^ SUStream on: '' ].
	
	indexA := self slides indexOf: previous.
	indexB := self slides indexOf: current.
			
	script add: (SUStream on: 'crossfade("', ajaxId, '-' , indexA asString ,'" , "', 
								ajaxId, '-' , indexB asString ,'", ',self transitionTime asString, ')').

	script element id: (ajaxId , '-tools'); update: [ :r | self renderToolsOn: r ].! !

!PRSlideshowCrossFade methodsFor: 'as yet unclassified' stamp: 'kph 3/11/2009 02:17'!
current: aStructure

	previous := current.
	super current: aStructure.! !

!PRSlideshowCrossFade methodsFor: 'as yet unclassified' stamp: 'kph 3/10/2009 02:59'!
delay

	^ self read: #descriptionDelay! !

!PRSlideshowCrossFade methodsFor: 'as yet unclassified' stamp: 'kph 3/11/2009 04:52'!
goNext
	"Go to the next slide, if we are looping loop around to the beginning again"

	self current: (self slides
		after: self current
		ifAbsent: [ self isLooping ifTrue: [ self slides first ] ifFalse: [ self current ] ])! !

!PRSlideshowCrossFade methodsFor: 'as yet unclassified' stamp: 'kph 3/10/2009 02:59'!
isLooping

	^ self read: #descriptionLooping! !

!PRSlideshowCrossFade methodsFor: 'as yet unclassified' stamp: 'kph 3/11/2009 04:31'!
renderControl: aString class: aClassString enabled: aBoolean action: aBlock on: html
	aBoolean
		ifTrue: [
			aBlock fixCallbackTemps.
			html anchor
				callback: aBlock;
				class: aClassString;
				onClick: (html evaluator
					callback: [ :s | 
						aBlock value.
						self applyCrossFadeTo: s.
					];
					return: false);
				with: aString ]
		ifFalse: [
			html span
				class: aClassString;
				with: aString ]! !

!PRSlideshowCrossFade methodsFor: 'as yet unclassified' stamp: 'kph 3/11/2009 04:50'!
renderSlideOn: html
	
	"for now we render all the slides 
		- dynamically loading the next slide with scriptaculous is left as an excercise"
	
	| div |
	
	self slides ifEmpty: [ ^ self ].
	
	div := html div class: 'slides'.
		
	self delay > 0 ifTrue: [ 
		
		div
			script: ( html evaluator
				every: self delay seconds;
				callback: [ :s | self goNext.
							   self applyCrossFadeTo: s. 
				]
			).	
	].
		
	div with: [			
	
			self slides keysAndValuesDo: [ :n :each | 
			
				html div
					style: (self styleForOpacity: (each = self current ifTrue: [ 0.99 ] ifFalse: [ 0.0 ]));
					id: (ajaxId, '-', n asString);
					class: 'slide'; 
					with: [ 
						self context renderer 
							continue: each 
							in: self on: html 
					]		
			]
	]
		
	! !

!PRSlideshowCrossFade methodsFor: 'as yet unclassified' stamp: 'kph 3/11/2009 03:33'!
renderSlideshowOn: html

	"render tools first since I have difficulty positioning them"
	
	self slides isEmpty
		ifFalse: [ 
			html div id: ajaxId, '-tools'; class: 'tools'; 
				
				with: [self renderToolsOn: html ].
		].
	
	self renderSlideOn: html.
! !

!PRSlideshowCrossFade methodsFor: 'as yet unclassified' stamp: 'kph 3/11/2009 02:51'!
renderToolsOn: html

		(self read: #descriptionFirstLast)
			ifTrue: [ self renderControlFirstOn: html ].
		(self read: #descriptionPrevNext)
			ifTrue: [ self renderControlPrevOn: html ].
		(self read: #descriptionSlideList)
			ifTrue: [ self renderControlSlideListOn: html ].
		(self read: #descriptionPrevNext)
			ifTrue: [ self renderControlNextOn: html ].
		(self read: #descriptionFirstLast)
			ifTrue: [ self renderControlLastOn: html ].
		(self read: #descriptionSlideNumber)
			ifTrue: [ self renderSlideNumberOn: html ]! !

!PRSlideshowCrossFade methodsFor: 'as yet unclassified' stamp: 'kph 3/11/2009 04:20'!
script

	^ '
	
function crossfade( outId, inId , timeMs) {
	
	elementOut = document.getElementById(outId);
	elementIn = document.getElementById(inId);

	step = 50.0 / timeMs;

	outOpacity = parseFloat(elementOut.style.opacity) - step;
 	inOpacity = parseFloat(elementIn.style.opacity) + step;
 
	elementIn.style.display = "block";
		
	setOpacity(elementOut, outOpacity); 
	setOpacity(elementIn, inOpacity);
	
	if(outOpacity<=0) {
		elementOut.style.display = "none";
	} else {
		setTimeout( "crossfade(''" + outId + "'', ''" + inId + "'' , " +  timeMs   + ")" , 50 );
	}
	
	function setOpacity(obj, val) {
		if(val>0.99) {
			val = 0.99;
		}
		obj.style.opacity = val;
		obj.style.filter= "progid:DXImageTransform.Microsoft.Alpha(Opacity=" + (val * 100) + ")";
	}
	
}'! !

!PRSlideshowCrossFade methodsFor: 'as yet unclassified' stamp: 'kph 3/11/2009 02:34'!
style

	^ '
.slides {
	position:relative;
	margin:auto;
}

.slides .slide {
	position: absolute;
	top: 0;
	left: 0;
}
'! !

!PRSlideshowCrossFade methodsFor: 'as yet unclassified' stamp: 'kph 3/10/2009 23:03'!
styleForOpacity: zeroToOne
	
	^ 'opacity : ', zeroToOne asString, '; ',
	'-ms-filter:"progid:DXImageTransform.Microsoft.Alpha(opacity=', (zeroToOne * 100 abs) asString, ')"; ',
	'filter : alpha(opacity=', (zeroToOne * 100 abs) asString, '); '.
	
	
			
	
		
! !

!PRSlideshowCrossFade methodsFor: 'as yet unclassified' stamp: 'kph 3/11/2009 02:08'!
transitionTime

	^ self read: #descriptionTransitionTime! !
PRSlideshow initialize!
